#!/usr/bin/env python

from optparse import OptionParser
import json
import os
from subprocess import Popen, PIPE
import sys
import traceback


"""

This script should be able to run on Python 2.6 as that is the version we
have on development VM. 

"""

curlrc_contents = """

-H "X-Endeavour-Sessionid: %s"
-H "Content-Type: application/json"
-H "Accept: application/json"

"""

def write_curlrc(sessionid):
    fname = "%s/.curlrc" % (os.environ["HOME"])
    
    with open(fname, "wt") as f:
        f.write(curlrc_contents % (sessionid,))

def process_options():
    global options, args

    parser = OptionParser()
    parser.add_option('--cred', dest='credentials',
                      help='Credentials in USERNAME:PASSWORD format.')
    
    parser.add_option('--host', dest='host', default="http://localhost:8082",
                        help='Target host URL.')
    
    (options, args) = parser.parse_args()

def main():
    process_options()

    cmd = ["/usr/bin/curl", "-k", "-s", "-X", "POST", "--user", options.credentials, "%s/api/endeavour/session?resPermissions=true" % options.host ]
    # cmd = ["/usr/bin/curl", "-k", "-s", "-X", "POST", "--user", options.credentials, "%s/api/endeavour/session" % options.host ]
    session_response = Popen(cmd, stdout=PIPE).communicate()[0]

    try:
        json_resp = json.loads(session_response)
        sessionid = json.loads(session_response)["sessionid"]
    except: 
        traceback.print_exc()
        print("session_response = %r", session_response)
        return
    
    write_curlrc(sessionid)

if __name__ == '__main__':
    main()
        

