#!/bin/bash

if [ $# -ne 1 ]; then
    echo "Usage $0 <slaname>"
    echo "Example $0 sla1"
    exit 0
fi

BASEDIR=$(dirname "$0")
echo "This will rebase SLA $1"
read -r -p "Are you sure? [y/N] " response
case "$response" in
    [yY][eE][sS]|[yY]) 
	output=`mongo --host localhost -u ecxadmin -p Ecx8dmin --authenticationDatabase=ECDB_master ECDB_master --port 27018 --eval "var slaName=\"$1\""  $BASEDIR/rebaseSLA.js` 
	echo "$output"
	if echo "$output" | grep -q  "nModified\" : 1"
	then
		echo "Successfully reset the SLA"
	else
		if echo "$output" | grep -q  "nMatched\" : 1";then
			echo "Successfully reset the SLA"
		else
			echo "Failed to reset SLA. Please check the input of the script and ensure it matched the name of the SLA"
		fi
	fi
        ;;
    *)
        ;;
esac

exit 0

