#!/usr/bin/env python

import re
import sys

def collapse_dots(trace):
    if not trace:
        return trace

    newtrace = []
    lastline = None
    for line in trace:
        if (line.find("...") == -1) or (lastline.find("...") == -1):
            newtrace.append(line)
            lastline = line
            continue

    return newtrace

stline_pat = re.compile("^(\s*)at (\S*)\(")

stacktrace = []
for line in sys.stdin:
    m = stline_pat.match(line)
    if m:
        initial_whitespace_size = len(m.group(1))
        class_name = m.group(2)

        if (class_name.find("slist") != -1) or (class_name.find("catalogic") != -1) or (class_name.find("syncsort") != -1) or (class_name.find(".") == -1) or (not stacktrace):
            stacktrace.append(line)
        else:
            stacktrace.append("        ...\n")

        continue

    if stacktrace:
        for x in collapse_dots(stacktrace):
            print x,

        stacktrace = []

    print line,

# If there are no lines after stack trace, print the trace.
if stacktrace:
    for x in collapse_dots(stacktrace):
        print x,

    
    
